## armadillo 12.6.7+dfsg

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# 
# Copyright 2008-2016 Conrad Sanderson (http://conradsanderson.id.au)
# Copyright 2008-2016 National ICT Australia (NICTA)
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ------------------------------------------------------------------------


## NOTE: If you prefer to link your programs _directly_ with OpenBLAS, BLAS or LAPACK,
## NOTE: do not use this installer.
## NOTE: To use Armadillo without installation, compile your programs along these lines:
## NOTE: g++ prog.cpp -o prog -O2 -I /home/user/armadillo-12.2.0/include -DARMA_DONT_USE_WRAPPER -lopenblas -llapack
## NOTE: The above command line assumes that you have unpacked the armadillo archive into /home/user/  
## NOTE: You will need to adjust this for newer versions of Armadillo (ie. "12.2.0" needs to be changed),
## NOTE: and/or if you have unpacked the armadillo archive into a different directory.
## NOTE: Replace -lopenblas with -lblas if you don't have OpenBLAS.
## NOTE: On macOS, replace -lblas -llapack with -framework Accelerate
## NOTE: More details: https://arma.sourceforge.net/faq.html


cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)

if(NOT (${CMAKE_MAJOR_VERSION} LESS 3))
  if(POLICY CMP0025)
    # enable differentiation between vanilla Clang and AppleClang
    cmake_policy(SET CMP0025 NEW)
    message(STATUS "*** set cmake policy CMP0025 to NEW")
  endif()
endif()

if(NOT (CMAKE_VERSION VERSION_LESS "3.1"))
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
  message(STATUS "CMAKE_CXX_STANDARD = ${CMAKE_CXX_STANDARD}")
endif()

project(armadillo CXX C)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)

set(ARMA_USE_WRAPPER true)

# the settings below will be automatically configured by the rest of this script

set(ARMA_USE_LAPACK  false)
set(ARMA_USE_BLAS    false)
set(ARMA_USE_ATLAS   false)
set(ARMA_USE_ARPACK  false)
set(ARMA_USE_SUPERLU false)  # Caveat: only SuperLU version 5.x can be used!


## extract version from sources

set(ARMA_VERSION_FILE_NAME "${PROJECT_SOURCE_DIR}/include/armadillo_bits/arma_version.hpp")

if(NOT EXISTS ${ARMA_VERSION_FILE_NAME})
  message(FATAL_ERROR "Can't read ${ARMA_VERSION_FILE_NAME}")
endif()

file(READ ${ARMA_VERSION_FILE_NAME} ARMA_VERSION_FILE_CONTENTS)
string(REGEX REPLACE ".*#define ARMA_VERSION_MAJOR ([0-9]+).*" "\\1" ARMA_VERSION_MAJOR "${ARMA_VERSION_FILE_CONTENTS}")
string(REGEX REPLACE ".*#define ARMA_VERSION_MINOR ([0-9]+).*" "\\1" ARMA_VERSION_MINOR "${ARMA_VERSION_FILE_CONTENTS}")
string(REGEX REPLACE ".*#define ARMA_VERSION_PATCH ([0-9]+).*" "\\1" ARMA_VERSION_PATCH "${ARMA_VERSION_FILE_CONTENTS}")

message(STATUS "Configuring Armadillo ${ARMA_VERSION_MAJOR}.${ARMA_VERSION_MINOR}.${ARMA_VERSION_PATCH}")

string(COMPARE EQUAL "${CMAKE_CXX_FLAGS}" "" CXX_FLAGS_EMPTY)
if(NOT CXX_FLAGS_EMPTY)
  message(STATUS "")
  message(STATUS "*** WARNING: variable 'CMAKE_CXX_FLAGS' is not empty; this may cause problems!")
  message(STATUS "")
endif()


# NOTE: Armadillo requires compiler support for thread_local and C++11
# NOTE: for Linux, this is available with gcc 4.8.3 onwards
# NOTE: for macOS, thread_local is supoported in Xcode 8 (mid 2016 onwards) in C++11 mode

# NOTE: thread_local appears broken again on macOS 11 (Big Sur) and/or AppleClang 12.0
# NOTE: see comments in include/armadillo_bits/arma_rng.hpp

if(DEFINED CMAKE_CXX_COMPILER_ID AND DEFINED CMAKE_CXX_COMPILER_VERSION)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.8.3))
      message(STATUS "Detected gcc 4.8.3 or newer")
      if(${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 6.1.0)
        message(STATUS "*** WARNING: support for gcc versions older than 6.1 is deprecated")
      endif()
      if(NOT DEFINED CMAKE_CXX_STANDARD)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        message(STATUS "Added '-std=c++11' to compiler flags")
      endif()
    else()
      message(FATAL_ERROR "Compiler too old")
    endif()
  else()
    if(NOT (${CMAKE_MAJOR_VERSION} LESS 3))
      if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        if(NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 6.0)
          message(STATUS "Detected Clang 6.0 or newer")
          if(NOT DEFINED CMAKE_CXX_STANDARD)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
            message(STATUS "Added '-std=c++14' to compiler flags")
          endif()
        else()
          message(FATAL_ERROR "Compiler too old")
        endif()
      elseif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
        if(NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 8.0)
          message(STATUS "Detected AppleClang 8.0 or newer")
          if(NOT DEFINED CMAKE_CXX_STANDARD)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
            message(STATUS "Added '-std=c++14' to compiler flags")
          endif()
        else()
          message(FATAL_ERROR "Compiler too old")
        endif()
      endif()
    endif()
  endif()
endif()


# As Red Hat Enterprise Linux (and related systems such as Fedora)
# does not search /usr/local/lib by default, we need to place the
# library in either /usr/lib or /usr/lib64

if(NOT APPLE)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    message(STATUS "*** CMAKE_INSTALL_PREFIX was initalised by cmake to the default value of ${CMAKE_INSTALL_PREFIX}")
    message(STATUS "*** CMAKE_INSTALL_PREFIX changed to /usr")
    set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Standard install prefix" FORCE)
  endif()
endif()


# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

# deprecated options
set(INSTALL_LIB_DIR     "" CACHE STRING "deprecated; use CMAKE_INSTALL_LIBDIR instead")
set(INSTALL_INCLUDE_DIR "" CACHE STRING "deprecated; use CMAKE_INSTALL_INCLUDEDIR instead")
set(INSTALL_DATA_DIR    "" CACHE STRING "deprecated; use CMAKE_INSTALL_DATADIR instead")
set(INSTALL_BIN_DIR     "" CACHE STRING "deprecated; use CMAKE_INSTALL_BINDIR instead")

if(INSTALL_LIB_DIR)
  message(STATUS "*** INSTALL_LIB_DIR is deprecated; use CMAKE_INSTALL_LIBDIR instead")
  set(CMAKE_INSTALL_LIBDIR "${INSTALL_LIB_DIR}")
  GNUInstallDirs_get_absolute_install_dir(CMAKE_INSTALL_FULL_LIBDIR CMAKE_INSTALL_LIBDIR)
endif()

if(INSTALL_INCLUDE_DIR)
  message(STATUS "*** INSTALL_INCLUDE_DIR is deprecated; use CMAKE_INSTALL_INCLUDEDIR instead")
  set(CMAKE_INSTALL_INCLUDEDIR "${INSTALL_INCLUDE_DIR}")
  GNUInstallDirs_get_absolute_install_dir(CMAKE_INSTALL_FULL_INCLUDEDIR CMAKE_INSTALL_INCLUDEDIR)
endif()

if(INSTALL_DATA_DIR)
  message(STATUS "*** INSTALL_DATA_DIR is deprecated; use CMAKE_INSTALL_DATADIR instead")
  set(CMAKE_INSTALL_DATADIR "${INSTALL_DATA_DIR}")
endif()

if(INSTALL_BIN_DIR)
  message(STATUS "*** INSTALL_BIN_DIR is deprecated; use CMAKE_INSTALL_BINDIR instead")
  set(CMAKE_INSTALL_BINDIR "${INSTALL_BIN_DIR}")
endif()


if(MSVC)
  option(BUILD_SHARED_LIBS "build shared library" OFF)
else()
  option(BUILD_SHARED_LIBS "build shared library" ON)
endif()

option(OPENBLAS_PROVIDES_LAPACK "Assume that OpenBLAS provides LAPACK functions" OFF)
## Example use on the command line:
## cmake -D OPENBLAS_PROVIDES_LAPACK=true .

option(ALLOW_FLEXIBLAS_LINUX "Allow detection of FlexiBLAS on Linux" ON)
# set(ALLOW_FLEXIBLAS_LINUX false)
## uncomment the above line to disable the detection of FlexiBLAS;
## you can also disable FlexiBLAS detection directly on the command line:
## cmake -D ALLOW_FLEXIBLAS_LINUX=false .

option(ALLOW_OPENBLAS_MACOS "Allow detection of OpenBLAS on macOS" OFF)
## Example use on the command line:
## cmake -D ALLOW_OPENBLAS_MACOS=true .

option(ALLOW_BLAS_LAPACK_MACOS "Allow detection of BLAS and LAPACK on macOS" OFF)
## Example use on the command line:
## cmake -D ALLOW_BLAS_LAPACK_MACOS=true .

option(BUILD_SMOKE_TEST "Build the smoke test" ON)
# set(BUILD_SMOKE_TEST false)
## uncomment the above line to disable building the smoke test;
## you can also disable building the smoke test directly on the command line:
## cmake -D BUILD_SMOKE_TEST=false .
## 
## to run the smoke test on the command line:
## make
## ctest


if(WIN32)
  message(STATUS "")
  message(STATUS "*** WARNING: automatic installation is experimental for this platform.")
  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
  message(STATUS "*** WARNING: manual installation is described in the README file.")
  message(STATUS "")
endif()

if(MSVC AND BUILD_SHARED_LIBS)
  message(STATUS "")
  message(STATUS "*** WARNING: building shared library with MSVC is not supported." )
  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
  message(STATUS "")
endif()


message(STATUS "CMAKE_SYSTEM_NAME          = ${CMAKE_SYSTEM_NAME}"         )
message(STATUS "CMAKE_CXX_COMPILER_ID      = ${CMAKE_CXX_COMPILER_ID}"     )
message(STATUS "CMAKE_CXX_COMPILER_VERSION = ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "CMAKE_COMPILER_IS_GNUCXX   = ${CMAKE_COMPILER_IS_GNUCXX}"  )

message(STATUS "")
message(STATUS "*** Options:"                                           )
message(STATUS "BUILD_SHARED_LIBS         = ${BUILD_SHARED_LIBS}"       )
message(STATUS "OPENBLAS_PROVIDES_LAPACK  = ${OPENBLAS_PROVIDES_LAPACK}")
message(STATUS "ALLOW_FLEXIBLAS_LINUX     = ${ALLOW_FLEXIBLAS_LINUX}"   )
message(STATUS "ALLOW_OPENBLAS_MACOS      = ${ALLOW_OPENBLAS_MACOS}"    )
message(STATUS "ALLOW_BLAS_LAPACK_MACOS   = ${ALLOW_BLAS_LAPACK_MACOS}" )
message(STATUS "BUILD_SMOKE_TEST          = ${BUILD_SMOKE_TEST}"        )

message(STATUS "")
message(STATUS "*** Looking for external libraries")

##
## Find LAPACK and BLAS libraries, or their optimised versions
##

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_aux/Modules/")

if(APPLE)
  message(STATUS "Detected macOS")
  
  set(ARMA_USE_LAPACK     true)
  set(ARMA_USE_BLAS       true)
  set(ARMA_USE_ACCELERATE true)
  
  if(ALLOW_OPENBLAS_MACOS)
    include(ARMA_FindOpenBLAS)
    message(STATUS "OpenBLAS_FOUND = ${OpenBLAS_FOUND}")
    message(STATUS "")
    message(STATUS "*** If use of OpenBLAS is causing problems,")
    message(STATUS "*** rerun cmake with detection of OpenBLAS disabled:")
    message(STATUS "*** cmake -D ALLOW_OPENBLAS_MACOS=false .")
    message(STATUS "")
    
    if(OpenBLAS_FOUND)
      set(ARMA_LIBS ${ARMA_LIBS} ${OpenBLAS_LIBRARIES})
      set(ARMA_USE_ACCELERATE false)
    endif()
  endif()
  
  if(ALLOW_BLAS_LAPACK_MACOS)
    include(ARMA_FindBLAS)
    include(ARMA_FindLAPACK)
    message(STATUS "  BLAS_FOUND = ${BLAS_FOUND}"  )
    message(STATUS "LAPACK_FOUND = ${LAPACK_FOUND}")
    message(STATUS "")
    message(STATUS "*** If use of BLAS and LAPACK is causing problems,")
    message(STATUS "*** rerun cmake with detection of BLAS and LAPACK disabled:")
    message(STATUS "*** cmake -D ALLOW_BLAS_LAPACK_MACOS=false .")
    message(STATUS "")
    
    if(BLAS_FOUND AND LAPACK_FOUND)
      set(ARMA_LIBS ${ARMA_LIBS} ${BLAS_LIBRARIES})
      set(ARMA_LIBS ${ARMA_LIBS} ${LAPACK_LIBRARIES})
      set(ARMA_USE_ACCELERATE false)
    endif()
  endif()
  
  if(ARMA_USE_ACCELERATE)
    set(ARMA_LIBS ${ARMA_LIBS} "-framework Accelerate")  # or "-framework accelerate" ?
    message(STATUS "Added '-framework Accelerate' to compiler flags")
  endif()
  
  if(DEFINED CMAKE_CXX_COMPILER_ID)
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")

=== tests1/CMakeLists.txt ===
add_executable(smoke_test smoke_test.cpp)
target_link_libraries(smoke_test PRIVATE armadillo)
enable_testing()

add_test(NAME smoke_test COMMAND smoke_test)

=== debian/changelog ===
armadillo (1:12.6.7+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:27:45 +0000

armadillo (1:12.6.7+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libarpack2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 07:32:24 +0000

armadillo (1:12.6.7+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Fri, 22 Dec 2023 11:47:19 +0530

armadillo (1:12.6.4+dfsg-2) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 27 Sep 2023 18:43:36 +0530

armadillo (1:12.6.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Thu, 31 Aug 2023 09:28:39 +0530

armadillo (1:12.6.1+dfsg-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Remove field Section on binary package libarmadillo11 that duplicates
    source.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dpkg-dev and libsuperlu-dev.
    + libarmadillo-dev: Drop versioned constraint on libsuperlu-dev in Depends.

  [ Kumar Appaiah ]
  * New upstream release
  * soname update to 12, add libarmadillo12 package
  * Override Lintian error saying that docs.html is autogenerated
  * Standards version is now 4.6.2 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Fri, 28 Jul 2023 19:06:12 +0530

=== debian/control ===
Source: armadillo
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kumar Appaiah <akumar@debian.org>
Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
Standards-Version: 4.6.2
Section: libs
Homepage: https://arma.sourceforge.net/
Vcs-Git: https://salsa.debian.org/science-team/armadillo.git
Vcs-Browser: https://salsa.debian.org/science-team/armadillo

Package: libarmadillo-dev
Section: libdevel
Architecture: any
Suggests: libitpp-dev
Depends: libarmadillo12 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
Replaces: libarmadillo-doc (<= 1.1.2-1)
Conflicts: libarmadillo-doc
Description: streamlined C++ linear algebra library - Headers
 Armadillo is a streamlined C++ linear algebra library (matrix maths)
 aiming towards a good balance between speed and ease of use. Integer,
 floating point and complex numbers are supported, as well as a subset
 of trigonometric and statistics functions. Optional integration with
 LAPACK and ATLAS libraries is also provided.
 .
 This package has the development libraries and headers for Armadillo.

Package: libarmadillo12
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: streamlined C++ linear algebra library
 Armadillo is a streamlined C++ linear algebra library (matrix maths)
 aiming towards a good balance between speed and ease of use. Integer,
 floating point and complex numbers are supported, as well as a subset
 of trigonometric and statistics functions. Optional integration with
 LAPACK and ATLAS libraries is also provided.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/quilt/quilt.make
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	dh_auto_configure --buildsystem=cmake --builddirectory=. -- -D INSTALL_LIB_DIR=lib -D CMAKE_INpppSTALL_PREFIX_INITIALIZED_TO_DEFAULT:BOOL=ON  . # specified to install to the debian/tmp directory.
	$(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf debian/doc_gen
	[ ! -f Makefile ] || $(MAKE) clean
	rm -f config.guess config.sub Makefile
	rm -f CMakeCache.txt cmake_install.cmake
	rm -rf CMakeFiles
	rm -f install_manifest.txt include/armadillo_bits/config.hpp examples/Makefile
	rm -f ArmadilloConfig.cmake ArmadilloConfigVersion.cmake
	rm -rf InstallFiles tmp *.o a.out
	dh_clean  --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig

install: build
	dh_testdir
	dh_testroot
	dh_prep --exclude ./src/include/armadillo_bits/dgemm_proto.hpp.orig
	dh_installdirs
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install DESTDIR=debian/tmp

binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp
	mkdir -p debian/libarmadillo-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	cp debian/tmp/usr/lib/pkgconfig/armadillo.pc debian/libarmadillo-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_compress -a -X.cpp
	dh_fixperms -a
	dh_makeshlibs -a -V
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: build install
# Currently no arch-independent packages

binary: binary-indep binary-arch
.PHONY: build clean binary-arch binary install

## armadillo 12.8.2+dfsg

=== debian/changelog ===
armadillo (1:12.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Sun, 05 May 2024 22:24:39 +0530

## armadillo 14.0.1+dfsg

=== debian/changelog ===
armadillo (1:14.0.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Mon, 15 Jul 2024 19:13:30 +0530

armadillo (1:14.0.1+dfsg-1) experimental; urgency=medium

  * New upstream release
  * soname bump to 14

 -- Kumar Appaiah <akumar@debian.org>  Tue, 09 Jul 2024 08:50:45 +0530

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: armadillo
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
 Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
 Standards-Version: 4.6.2
@@ -14,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Suggests: libitpp-dev
-Depends: libarmadillo12 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
+Depends: libarmadillo14 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
 Replaces: libarmadillo-doc (<= 1.1.2-1)
 Conflicts: libarmadillo-doc
 Description: streamlined C++ linear algebra library - Headers
@@ -26,7 +25,7 @@
  .
  This package has the development libraries and headers for Armadillo.
 
-Package: libarmadillo12
+Package: libarmadillo14
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: streamlined C++ linear algebra library

## armadillo 14.2.1+dfsg

=== debian/changelog ===
armadillo (1:14.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Standards version is 4.7.0 (no changes)

 -- Kumar Appaiah <akumar@debian.org>  Mon, 02 Dec 2024 15:20:38 +0530

armadillo (1:14.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Thu, 05 Sep 2024 22:30:08 +0530

## armadillo 14.2.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,43 +16,59 @@
 # ------------------------------------------------------------------------
 
 
-## NOTE: If you prefer to link your programs _directly_ with OpenBLAS, BLAS or LAPACK,
-## NOTE: do not use this installer.
-## NOTE: To use Armadillo without installation, compile your programs along these lines:
-## NOTE: g++ prog.cpp -o prog -O2 -I /home/user/armadillo-12.2.0/include -DARMA_DONT_USE_WRAPPER -lopenblas -llapack
+## NOTE: This installation script by default generates a runtime wrapper library,
+## NOTE: which links with OpenBLAS, LAPACK, etc.
+## NOTE: 
+## NOTE: If you prefer to link your programs directly with OpenBLAS, LAPACK, etc
+## NOTE: there are two options:
+## NOTE: (1) use the HEADER_ONLY option when running this installation script,
+## NOTE: or
+## NOTE: (2) do not use this installation script, and instead compile your programs
+## NOTE: using the include folder directly obtained from the armadillo archive.
+## NOTE: 
+## NOTE: To forcefully disable use of the runtime wrapper library,
+## NOTE: compile your programs with ARMA_DONT_USE_WRAPPER enabled.
+## NOTE: For example:
+## NOTE: g++ prog.cpp -o prog -O2 -I /home/user/armadillo-14.0.0/include -DARMA_DONT_USE_WRAPPER -lopenblas -llapack
+## NOTE: 
 ## NOTE: The above command line assumes that you have unpacked the armadillo archive into /home/user/  
-## NOTE: You will need to adjust this for newer versions of Armadillo (ie. "12.2.0" needs to be changed),
-## NOTE: and/or if you have unpacked the armadillo archive into a different directory.
+## NOTE: This needs to be adjusted for newer versions of Armadillo (ie. change "14.0.0"),
+## NOTE: and/or if the armadillo archive has been unpacked into a different folder.
+## NOTE: 
 ## NOTE: Replace -lopenblas with -lblas if you don't have OpenBLAS.
 ## NOTE: On macOS, replace -lblas -llapack with -framework Accelerate
 ## NOTE: More details: https://arma.sourceforge.net/faq.html
 
 
-cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
-
-if(NOT (${CMAKE_MAJOR_VERSION} LESS 3))
-  if(POLICY CMP0025)
-    # enable differentiation between vanilla Clang and AppleClang
-    cmake_policy(SET CMP0025 NEW)
-    message(STATUS "*** set cmake policy CMP0025 to NEW")
-  endif()
-endif()
-
-if(NOT (CMAKE_VERSION VERSION_LESS "3.1"))
-  set(CMAKE_CXX_STANDARD 11)
-  set(CMAKE_CXX_STANDARD_REQUIRED ON)
-  set(CMAKE_CXX_EXTENSIONS OFF)
-  message(STATUS "CMAKE_CXX_STANDARD = ${CMAKE_CXX_STANDARD}")
+cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
+
+if(POLICY CMP0025)
+  # enable differentiation between vanilla Clang and AppleClang
+  cmake_policy(SET CMP0025 NEW)
+  message(STATUS "*** set cmake policy CMP0025 to NEW")
+endif()
+
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+message(STATUS "CMAKE_CXX_STANDARD = ${CMAKE_CXX_STANDARD}")
+
+if(WIN32)
+  message(STATUS "")
+  message(STATUS "*** WARNING: installation via cmake is not supported on this platform.")
+  message(STATUS "*** WARNING: suggest to use manual installation instead;")
+  message(STATUS "*** WARNING: see README for details")
+  message(STATUS "")
 endif()
 
 project(armadillo CXX C)
 include(CheckIncludeFileCXX)
 include(CheckLibraryExists)
 
-set(ARMA_USE_WRAPPER true)
 
 # the settings below will be automatically configured by the rest of this script
 
+set(ARMA_USE_WRAPPER false)
 set(ARMA_USE_LAPACK  false)
 set(ARMA_USE_BLAS    false)
 set(ARMA_USE_ATLAS   false)
@@ -60,7 +76,7 @@
 set(ARMA_USE_SUPERLU false)  # Caveat: only SuperLU version 5.x can be used!
 
 
-## extract version from sources
+# extract version from sources
 
 set(ARMA_VERSION_FILE_NAME "${PROJECT_SOURCE_DIR}/include/armadillo_bits/arma_version.hpp")
 
@@ -83,26 +99,15 @@
 endif()
 
 
-# NOTE: Armadillo requires compiler support for thread_local and C++11
-# NOTE: for Linux, this is available with gcc 4.8.3 onwards
-# NOTE: for macOS, thread_local is supoported in Xcode 8 (mid 2016 onwards) in C++11 mode
-
-# NOTE: thread_local appears broken again on macOS 11 (Big Sur) and/or AppleClang 12.0
-# NOTE: see comments in include/armadillo_bits/arma_rng.hpp
-
 if(DEFINED CMAKE_CXX_COMPILER_ID AND DEFINED CMAKE_CXX_COMPILER_VERSION)
   if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.8.3))
-      message(STATUS "Detected gcc 4.8.3 or newer")
-      if(${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 6.1.0)
-        message(STATUS "*** WARNING: support for gcc versions older than 6.1 is deprecated")
-      endif()
+    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 6.1.0))
       if(NOT DEFINED CMAKE_CXX_STANDARD)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
-        message(STATUS "Added '-std=c++11' to compiler flags")
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+        message(STATUS "Added '-std=c++14' to compiler flags")
       endif()
     else()
-      message(FATAL_ERROR "Compiler too old")
+      message(FATAL_ERROR "Compiler too old; need at least gcc 6.1")
     endif()
   else()
     if(NOT (${CMAKE_MAJOR_VERSION} LESS 3))
@@ -138,6 +143,7 @@
 
 if(NOT APPLE)
   if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+    message(STATUS "")
     message(STATUS "*** CMAKE_INSTALL_PREFIX was initalised by cmake to the default value of ${CMAKE_INSTALL_PREFIX}")
     message(STATUS "*** CMAKE_INSTALL_PREFIX changed to /usr")
     set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Standard install prefix" FORCE)
@@ -177,11 +183,18 @@
 endif()
 
 
+
+option(HEADER_ONLY "Do not generate the wrapper library" OFF)
+## Example use on the command line:
+## cmake -D HEADER_ONLY=true .
+
 if(MSVC)
-  option(BUILD_SHARED_LIBS "build shared library" OFF)
+  option(STATIC_LIB "Generate static library instead of shared library" ON)
 else()
-  option(BUILD_SHARED_LIBS "build shared library" ON)
-endif()
+  option(STATIC_LIB "Generate static library instead of shared library" OFF)
+endif()
+## Example use on the command line:
+## cmake -D STATIC_LIB=true .
 
 option(OPENBLAS_PROVIDES_LAPACK "Assume that OpenBLAS provides LAPACK functions" OFF)
 ## Example use on the command line:
@@ -212,30 +225,40 @@
 ## ctest
 
 
-if(WIN32)
-  message(STATUS "")
-  message(STATUS "*** WARNING: automatic installation is experimental for this platform.")
-  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
-  message(STATUS "*** WARNING: manual installation is described in the README file.")
-  message(STATUS "")
-endif()
-
-if(MSVC AND BUILD_SHARED_LIBS)
-  message(STATUS "")
-  message(STATUS "*** WARNING: building shared library with MSVC is not supported." )
-  message(STATUS "*** WARNING: if anything breaks, you get to keep all the pieces.")
-  message(STATUS "")
-endif()
-
-
+if(MSVC)
+  if(NOT STATIC_LIB)
+    message(STATUS "")
+    message(STATUS "*** WARNING: building shared library with MSVC is not supported." )
+    message(STATUS "*** WARNING: use manual installation instead; see README for details")
+    message(STATUS "")
+    
+    set(STATIC_LIB ON)
+  endif()
+endif()
+
+if(HEADER_ONLY)
+  set(BUILD_WRAPPER false)
+else()
+  set(BUILD_WRAPPER true)
+endif()
+
+if(BUILD_WRAPPER)
+  set(ARMA_USE_WRAPPER true)
+else()
+  set(ARMA_USE_WRAPPER false)
+endif()
+
+
+message(STATUS "")
 message(STATUS "CMAKE_SYSTEM_NAME          = ${CMAKE_SYSTEM_NAME}"         )
 message(STATUS "CMAKE_CXX_COMPILER_ID      = ${CMAKE_CXX_COMPILER_ID}"     )
 message(STATUS "CMAKE_CXX_COMPILER_VERSION = ${CMAKE_CXX_COMPILER_VERSION}")
 message(STATUS "CMAKE_COMPILER_IS_GNUCXX   = ${CMAKE_COMPILER_IS_GNUCXX}"  )
 
 message(STATUS "")
-message(STATUS "*** Options:"                                           )
-message(STATUS "BUILD_SHARED_LIBS         = ${BUILD_SHARED_LIBS}"       )
+message(STATUS "*** options:"                                           )
+message(STATUS "HEADER_ONLY               = ${HEADER_ONLY}"             )
+message(STATUS "STATIC_LIB                = ${STATIC_LIB}"              )
 message(STATUS "OPENBLAS_PROVIDES_LAPACK  = ${OPENBLAS_PROVIDES_LAPACK}")
 message(STATUS "ALLOW_FLEXIBLAS_LINUX     = ${ALLOW_FLEXIBLAS_LINUX}"   )
 message(STATUS "ALLOW_OPENBLAS_MACOS      = ${ALLOW_OPENBLAS_MACOS}"    )
@@ -292,10 +315,3 @@
   endif()
   
   if(ARMA_USE_ACCELERATE)
-    set(ARMA_LIBS ${ARMA_LIBS} "-framework Accelerate")  # or "-framework accelerate" ?
-    message(STATUS "Added '-framework Accelerate' to compiler flags")
-  endif()
-  
-  if(DEFINED CMAKE_CXX_COMPILER_ID)
-    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
-      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")

=== debian/changelog ===
armadillo (1:14.2.3+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Thu, 13 Feb 2025 07:24:13 +0530

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
 Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://arma.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/science-team/armadillo.git

## armadillo 15.0.1+dfsg

=== debian/changelog ===
armadillo (1:15.0.1+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Update copyrights and bump soname
  * Remove missing icon from docs file
  * Standards version is now 4.7.2
  * Enable parallel build for tests

 -- Kumar Appaiah <akumar@debian.org>  Sun, 31 Aug 2025 20:41:07 +0530

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
 Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://arma.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/science-team/armadillo.git
@@ -13,7 +13,7 @@
 Section: libdevel
 Architecture: any
 Suggests: libitpp-dev
-Depends: libarmadillo14 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
+Depends: libarmadillo15 (= ${binary:Version}), ${misc:Depends}, libarpack2-dev, libhdf5-dev, libsuperlu-dev
 Replaces: libarmadillo-doc (<= 1.1.2-1)
 Conflicts: libarmadillo-doc
 Description: streamlined C++ linear algebra library - Headers
@@ -25,7 +25,7 @@
  .
  This package has the development libraries and headers for Armadillo.
 
-Package: libarmadillo14
+Package: libarmadillo15
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: streamlined C++ linear algebra library

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,11 @@
 CFLAGS+=$(CPPFLAGS)
 CXXFLAGS+=$(CPPFLAGS)
 
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+MAKEFLAGS += -j$(NUMJOBS)
+endif
+
 build: build-arch build-indep
 build-arch: build-stamp
 build-indep: build-stamp
@@ -15,6 +20,8 @@
 	dh_testdir
 	dh_auto_configure --buildsystem=cmake --builddirectory=. -- -D INSTALL_LIB_DIR=lib -D CMAKE_INpppSTALL_PREFIX_INITIALIZED_TO_DEFAULT:BOOL=ON  . # specified to install to the debian/tmp directory.
 	$(MAKE)
+	cd tests1 && LD_LIBRARY_PATH=.. ./smoke_test && cd ..
+	cd tests2 && $(MAKE) && LD_LIBRARY_PATH=.. ./main && cd ..
 	touch $@
 
 clean:

## armadillo 15.2.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # SPDX-License-Identifier: Apache-2.0
 # 
-# Copyright 2008-2016 Conrad Sanderson (http://conradsanderson.id.au)
+# Copyright 2008-2016 Conrad Sanderson (https://conradsanderson.id.au)
 # Copyright 2008-2016 National ICT Australia (NICTA)
 # 
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
-# http://www.apache.org/licenses/LICENSE-2.0
+# https://www.apache.org/licenses/LICENSE-2.0
 # 
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
@@ -16,23 +16,24 @@
 # ------------------------------------------------------------------------
 
 
-## NOTE: This installation script by default generates a runtime wrapper library,
+## NOTE: This installation script generates a runtime wrapper library by default,
 ## NOTE: which links with OpenBLAS, LAPACK, etc.
 ## NOTE: 
 ## NOTE: If you prefer to link your programs directly with OpenBLAS, LAPACK, etc
 ## NOTE: there are two options:
+## NOTE: 
 ## NOTE: (1) use the HEADER_ONLY option when running this installation script,
 ## NOTE: or
-## NOTE: (2) do not use this installation script, and instead compile your programs
-## NOTE: using the include folder directly obtained from the armadillo archive.
+## NOTE: (2) do not use this installation script; instead compile your programs
+## NOTE:     using the include folder directly obtained from the armadillo archive.
 ## NOTE: 
 ## NOTE: To forcefully disable use of the runtime wrapper library,
 ## NOTE: compile your programs with ARMA_DONT_USE_WRAPPER enabled.
-## NOTE: For example:
+## NOTE: Example:
 ## NOTE: g++ prog.cpp -o prog -O2 -I /home/user/armadillo-14.0.0/include -DARMA_DONT_USE_WRAPPER -lopenblas -llapack
 ## NOTE: 
-## NOTE: The above command line assumes that you have unpacked the armadillo archive into /home/user/  
-## NOTE: This needs to be adjusted for newer versions of Armadillo (ie. change "14.0.0"),
+## NOTE: The above assumes that the armadillo archive is unpacked into /home/user/  
+## NOTE: Adjust for newer versions of Armadillo (change "14.0.0"),
 ## NOTE: and/or if the armadillo archive has been unpacked into a different folder.
 ## NOTE: 
 ## NOTE: Replace -lopenblas with -lblas if you don't have OpenBLAS.
@@ -40,7 +41,7 @@
 ## NOTE: More details: https://arma.sourceforge.net/faq.html
 
 
-cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.10 FATAL_ERROR)
 
 if(POLICY CMP0025)
   # enable differentiation between vanilla Clang and AppleClang
@@ -73,7 +74,7 @@
 set(ARMA_USE_BLAS    false)
 set(ARMA_USE_ATLAS   false)
 set(ARMA_USE_ARPACK  false)
-set(ARMA_USE_SUPERLU false)  # Caveat: only SuperLU version 5.x can be used!
+set(ARMA_USE_SUPERLU false)
 
 
 # extract version from sources
@@ -101,13 +102,13 @@
 
 if(DEFINED CMAKE_CXX_COMPILER_ID AND DEFINED CMAKE_CXX_COMPILER_VERSION)
   if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 6.1.0))
+    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 8.1.0))
       if(NOT DEFINED CMAKE_CXX_STANDARD)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
         message(STATUS "Added '-std=c++14' to compiler flags")
       endif()
     else()
-      message(FATAL_ERROR "Compiler too old; need at least gcc 6.1")
+      message(FATAL_ERROR "Compiler too old; need at least gcc 8.1")
     endif()
   else()
     if(NOT (${CMAKE_MAJOR_VERSION} LESS 3))
@@ -144,7 +145,7 @@
 if(NOT APPLE)
   if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
     message(STATUS "")
-    message(STATUS "*** CMAKE_INSTALL_PREFIX was initalised by cmake to the default value of ${CMAKE_INSTALL_PREFIX}")
+    message(STATUS "*** CMAKE_INSTALL_PREFIX was initialised by cmake to the default value of ${CMAKE_INSTALL_PREFIX}")
     message(STATUS "*** CMAKE_INSTALL_PREFIX changed to /usr")
     set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Standard install prefix" FORCE)
   endif()
@@ -315,3 +316,4 @@
   endif()
   
   if(ARMA_USE_ACCELERATE)
+    set(ARMA_LIBS ${ARMA_LIBS} "-framework Accelerate")  # or "-framework accelerate" ?

=== debian/changelog ===
armadillo (1:15.2.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Kumar Appaiah <akumar@debian.org>  Thu, 06 Nov 2025 09:45:34 +0530

armadillo (1:15.2.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Kumar Appaiah <akumar@debian.org>  Wed, 29 Oct 2025 21:49:25 +0530

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Kumar Appaiah <akumar@debian.org>
-Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev, quilt
+Build-Depends: debhelper (>= 10), libblas-dev, liblapack-dev, cmake, libarpack2-dev, libsuperlu-dev
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://arma.sourceforge.net/

=== debian/watch ===
version=4
opts=dversionmangle=s/\.dfsg\.\d+//,repacksuffix=+dfsg,compression=xz \
http://sf.net/arma/ armadillo-([0-9.][0-9.]+)\.tar\.xz debian uupdate
